/* --------------------------------------------------------------  */
/* (C)Copyright 2007,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#ifndef __INCLUDE_FFT16M_H__
#define __INCLUDE_FFT16M_H__

#define NP 16777216    /* number of points (16 meg) */
#define M_PI           3.14159265358979323846
#define FULLRUN
//#define MAMBO_RUN

//#define P_M
//#define SINGLE_USE
#define MULTI_USE 

#ifndef _ALF_PLATFORM_HYBRID_
#define SIMD_DT_USE
#endif

#define STAGE_NUM    3
#define DMANUM_FOR_SPU    256

/* The group ID of different stage */
enum {GRP_STAGE_1, GRP_STAGE_2, GRP_STAGE_3};

enum {IS_FFT = 1, IS_IFFT = -1};

typedef struct tagFFTPARAM
{
    unsigned long long  pInputDataArrayR;
    unsigned long long  pInputDataArrayI;	
    unsigned long long  pOutputDataArrayR;
    unsigned long long  pOutputDataArrayI;
    int                 nFFTFlag;
    int                 nSPU;
    int                 nDMA;
    short               nStage;
    short               is_SPU_DMA;
}FFTPARAM; 

#ifndef __SPU__

#if defined(__LP64__) || defined(__64BIT__) || defined(_LP64) || (__WORDSIZE == 64)
#define ADDR2ULL( p ) ((unsigned long long)(p))
#define ULL2ADDR( ull ) ((void *)(ull))
#else
#define ADDR2ULL( p ) ((unsigned long long)((unsigned int)(p)))
#define ULL2ADDR( ull ) ((void *)((unsigned int)((ull) & 0xFFFFFFFFUL)))
#endif

#endif

#endif /* __INCLUDE_FFT16M_H__ */
