/* --------------------------------------------------------------  */
/* (C)Copyright 2007,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#define ROW_SIZE        (1024)     // horizontal size
#define COL_SIZE        (1024)     // vertical size

#define PART_SIZE       (8)        // partition size in number of rows
 

typedef struct _my_wb_parms_t
{
    alf_data_uint32_t num_data;  // number of data in this WB
    alf_data_uint32_t dummy[3];  // padding
} my_wb_parms_t;




#if !defined(__GNUC__) && !defined(__IBMC__)
    #error "Your compiler is not supported yet !"
#endif

#if defined(__GNUC__)
    #if (__GNUC__ < 4) || ( !defined(__PPC__) && !defined(__SPU__) && !defined(__i386__) && !defined(__x86_64__)) || ( defined(__PPC__) && defined(__SPU__) && defined(__i386__) && defined(__x86_64__))
//    #if (__GNUC__ < 4) || ( !defined(__PPC__) && !defined(__SPU__) ) || ( defined(__PPC__) && defined(__SPU__) )
        #error "Your GCC compiler is not supported !"
    #else
        #ifdef __PPC__
            #ifdef __PPC64__
                #define _ALF_64B_   1
            #else
                #define _ALF_32B_   1
            #endif
        #elif __SPU__
            #define _ALF_32B_   1
        #elif __i386__
            #define _ALF_32B_   1
        #elif __x86_64__
            #define _ALF_64B_   1
        #endif
    #endif
#endif


#if defined(__IBMC__)
    #if (__IBMC__ < 800)
        #error "Your XLC compiler is not supported !"
    #else
        #ifdef __PPC__
            #ifdef __PPC64__
                #define _ALF_64B_   1
            #else
                #define _ALF_32B_   1
            #endif
        #else
            #define _ALF_32B_   1
        #endif
    #endif
#endif
#ifdef _ALF_32B_ //32Bit Compiler

  #define PTR_TO_ADDR64( ptr , addr) {                                  \
    (addr) = ( (unsigned long)(ptr) & 0xFFFFFFFFUL);      \
  }

  //! Macro to cast 64 bits effective address to a pointer
  #define ADDR64_TO_PTR( addr, type, ptr) { (ptr) = (type)((unsigned int)addr); }

  #define ADDR64_PTR_OFFSET(addr, offset) (addr.ui[1] + offset)

#elif _ALF_64B_ //64Bit Compiler

  #define PTR_TO_ADDR64( ptr , addr) {                                  \
    (addr) = (unsigned long long)(ptr);                             \
  }

  //! Macro to cast 64 bits effective address to a pointer
  #define ADDR64_TO_PTR( addr, type, ptr) { (ptr) = (type)(addr);}
  #define ADDR64_PTR_OFFSET(addr, offset) (addr + offset)

#elif //Unsupported compiler
  #error "Your compiler is not supported yet !"
#endif
