/* --------------------------------------------------------------  */
/* (C)Copyright 2007,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#include "mult_matrix4x4.h"
#include "inverse_matrix_matrix_spu.h"

void matrix_mul(float *a, float *b, float *c)
{
        const vector float A[4] __attribute__ ((aligned (128))) = {
                (vector float) {a[0],a[1],a[2],a[3]},
                (vector float) {a[4],a[5],a[6],a[7]},
                (vector float) {a[8],a[9],a[10],a[11]},
                (vector float) {a[12],a[13],a[14],a[15]},};

        const vector float B[4] __attribute__ ((aligned (128))) = {
                (vector float) {b[0],b[1],b[2],b[3]},
                (vector float) {b[4],b[5],b[6],b[7]},
                (vector float) {b[8],b[9],b[10],b[11]},
                (vector float) {b[12],b[13],b[14],b[15]},};


        vector float  C[4] __attribute__ ((aligned (128)));

        _mult_matrix4x4(C, A, B);

        c[0]=spu_extract(C[0],0);c[1]=spu_extract(C[0],1);c[2]=spu_extract(C[0],2);c[3]=spu_extract(C[0],3);
        c[4]=spu_extract(C[1],0);c[5]=spu_extract(C[1],1);c[6]=spu_extract(C[1],2);c[7]=spu_extract(C[1],3);
        c[8]=spu_extract(C[2],0);c[9]=spu_extract(C[2],1);c[10]=spu_extract(C[2],2);c[11]=spu_extract(C[2],3);
        c[12]=spu_extract(C[3],0);c[13]=spu_extract(C[3],1);c[14]=spu_extract(C[3],2);c[15]=spu_extract(C[3],3);

}


void inverse_BCA(float *a, float *b, float *c)
{
        float a1[4*4];
        float b1[4*4];
        float c1[4*4];
        float d1[4*4];

        get_block(c,c1);
        get_block(b,b1);
        matrix_mul(c1,b1,d1);
        get_block(a,a1);
        matrix_mul(d1,a1,b1);
        put_block(b1,b,-1);
}

